import type { Badge } from './types';

export function getBadges(badges: Badge[], badgesToFind: { setId: string; version: string; }[]) {
  const foundBadges = [];
  if(!badges) return

  for (let badgeToFind of badgesToFind) {
    const badge = badges
      .filter((badge) => badge.setId === badgeToFind.setId)
      .find((badge) => badge.version === badgeToFind.version);

    if (badge) {
      foundBadges.push(badge);
    }
  }

  return foundBadges;
}

export const getBadgesFromMessage = (message: { username: string, channel: string, message: string, messageType: string, tags: Record<string, string> }, allBadges: Badge[]) => {
    let badgesString = message.tags.badges;
    if (!badgesString) return;
    let badges = badgesString.split(',');
    let formatedBadges = badges.map((badgeWithVersion) => {
      const [setId, version] = badgeWithVersion.split('/');
      return { setId, version };
    });
  
    return getBadges(allBadges, formatedBadges);
  }